Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/master-9.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/master-9.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/master-9.dot
@@ -5,14 +5,24 @@
 "DoFencing_stop_0" [ style=bold color="green" fontcolor="orange" ]
 "DoFencing_stopped_0" [ style=bold color="green" fontcolor="orange" ]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
+"child_DoFencing:1_monitor_0 va1" -> "DoFencing_stopped_0" [ style = bold]
+"child_DoFencing:1_monitor_0 va1" -> "all_stopped" [ style = bold]
 "child_DoFencing:1_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_stop_0 ibm1" -> "DoFencing_stopped_0" [ style = bold]
 "child_DoFencing:1_stop_0 ibm1" -> "all_stopped" [ style = bold]
 "child_DoFencing:1_stop_0 ibm1" -> "do_shutdown ibm1" [ style = bold]
 "child_DoFencing:1_stop_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"child_DoFencing:2_monitor_0 ibm1" -> "DoFencing_stopped_0" [ style = bold]
+"child_DoFencing:2_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "child_DoFencing:2_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"child_DoFencing:2_monitor_0 va1" -> "DoFencing_stopped_0" [ style = bold]
+"child_DoFencing:2_monitor_0 va1" -> "all_stopped" [ style = bold]
 "child_DoFencing:2_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"child_DoFencing:3_monitor_0 ibm1" -> "DoFencing_stopped_0" [ style = bold]
+"child_DoFencing:3_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "child_DoFencing:3_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"child_DoFencing:3_monitor_0 va1" -> "DoFencing_stopped_0" [ style = bold]
+"child_DoFencing:3_monitor_0 va1" -> "all_stopped" [ style = bold]
 "child_DoFencing:3_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
 "do_shutdown ibm1" [ style=bold color="green" fontcolor="black" ]
 "heartbeat_127.0.0.12_monitor_5000 va1" [ style=dashed color="red" fontcolor="black" ]
@@ -21,17 +31,29 @@
 "ocf_127.0.0.13_monitor_5000 va1" [ style=dashed color="red" fontcolor="black" ]
 "ocf_msdummy:0_monitor_6000 va1" [ style=dashed color="red" fontcolor="black"]
 "ocf_msdummy:1_monitor_5000 va1" [ style=dashed color="red" fontcolor="black" ]
+"ocf_msdummy:2_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:2_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:2_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:2_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:3_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:3_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:3_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:3_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:4_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:4_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:4_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:4_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:5_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:5_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:5_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:5_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:6_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:6_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:6_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:6_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:7_monitor_0 ibm1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:7_monitor_0 ibm1" [ style=bold color="green" fontcolor="black" ]
+"ocf_msdummy:7_monitor_0 va1" -> "all_stopped" [ style = bold]
 "ocf_msdummy:7_monitor_0 va1" [ style=bold color="green" fontcolor="black" ]
 "rsc_ibm1_monitor_5000 va1" [ style=dashed color="red" fontcolor="black" ]
 "rsc_sgi2_monitor_5000 va1" [ style=dashed color="red" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/master-9.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/master-9.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/master-9.exp
@@ -65,6 +65,21 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
         <rsc_op id="45" operation="stop" operation_key="child_DoFencing:1_stop_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
        </trigger>
        <trigger>
@@ -211,6 +226,57 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="ocf_msdummy:2_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="ocf_msdummy:3_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="ocf_msdummy:4_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="ocf_msdummy:5_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="ocf_msdummy:6_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="ocf_msdummy:7_monitor_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="ocf_msdummy:2_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="ocf_msdummy:3_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="ocf_msdummy:4_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="18" operation="monitor" operation_key="ocf_msdummy:5_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="19" operation="monitor" operation_key="ocf_msdummy:6_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="20" operation="monitor" operation_key="ocf_msdummy:7_monitor_0" on_node="va1" on_node_uuid="b8f81462-2d65-42bf-bbb1-70db0ea29e5b"/>
+      </trigger>
+      <trigger>
         <rsc_op id="45" operation="stop" operation_key="child_DoFencing:1_stop_0" on_node="ibm1" on_node_uuid="d0d76dd9-7a01-4c12-bbec-98aa2a669638"/>
       </trigger>
     </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-1.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-1.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-1.dot
@@ -5,6 +5,7 @@
 "rsc3_migrate_from_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc3_migrate_to_0 node1" -> "rsc3_migrate_from_0 node2" [ style = bold]
 "rsc3_migrate_to_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node2" -> "rsc3_migrate_to_0 node1" [ style = bold]
 "rsc3_monitor_0 node2" -> "rsc3_start_0 node2" [ style = bold]
 "rsc3_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-1.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-1.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-1.exp
@@ -73,6 +73,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="3" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="node1"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-3.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-3.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-3.dot
@@ -1,5 +1,6 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc3_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node2" -> "rsc3_start_0 node2" [ style = bold]
 "rsc3_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc3_start_0 node2" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-3.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-3.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-3.exp
@@ -43,6 +43,9 @@
        <trigger>
         <rsc_op id="1" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="node1"/>
        </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="node2"/>
+      </trigger>
      </inputs>
    </synapse>
  </transition_graph>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-start-complex.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-start-complex.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-start-complex.dot
@@ -1,9 +1,11 @@
 digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"bottom:0_monitor_0 dom0-01" -> "all_stopped" [ style = bold]
 "bottom:0_monitor_0 dom0-01" -> "clone-bottom_start_0" [ style = bold]
 "bottom:0_monitor_0 dom0-01" [ style=bold color="green" fontcolor="black" ]
 "bottom:0_start_0 dom0-01" -> "clone-bottom_running_0" [ style = bold]
 "bottom:0_start_0 dom0-01" [ style=bold color="green" fontcolor="black" ]
+"bottom:1_monitor_0 dom0-02" -> "all_stopped" [ style = bold]
 "bottom:1_monitor_0 dom0-02" -> "clone-bottom_start_0" [ style = bold]
 "bottom:1_monitor_0 dom0-02" [ style=bold color="green" fontcolor="black" ]
 "bottom:1_start_0 dom0-02" -> "clone-bottom_running_0" [ style = bold]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-start-complex.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/migrate-start-complex.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/migrate-start-complex.exp
@@ -241,6 +241,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="bottom:0_monitor_0" on_node="dom0-01" on_node_uuid="dom0-01"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="bottom:1_monitor_0" on_node="dom0-02" on_node_uuid="dom0-02"/>
+      </trigger>
+      <trigger>
         <rsc_op id="4" operation="stop" operation_key="top_stop_0" on_node="dom0-02" on_node_uuid="dom0-02"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-2.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/mon-rsc-2.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-2.dot
@@ -1,5 +1,6 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "rsc1_monitor_0 node1" -> "rsc1_start_0 node1" [ style = bold]
 "rsc1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "rsc1_monitor_5000 node1" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-2.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/mon-rsc-2.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-2.exp
@@ -54,6 +54,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="3" operation="stop" operation_key="rsc1_stop_0" on_node="node2" on_node_uuid="uuid2"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-4.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/mon-rsc-4.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-4.dot
@@ -1,5 +1,6 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "rsc1_monitor_0 node1" -> "rsc1_start_0 node1" [ style = bold]
 "rsc1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "rsc1_monitor_5000 node1" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-4.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/mon-rsc-4.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/mon-rsc-4.exp
@@ -54,6 +54,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="4" operation="stop" operation_key="rsc1_stop_0" on_node="node2" on_node_uuid="uuid2"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-0.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/notify-0.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-0.exp
@@ -78,6 +78,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="11" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
        <trigger>
@@ -101,6 +104,12 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="child_rsc1:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="11" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-1.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/notify-1.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-1.exp
@@ -239,6 +239,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="19" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
       <trigger>
@@ -266,6 +269,12 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="child_rsc1:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="19" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
        <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-2.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/notify-2.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-2.exp
@@ -239,6 +239,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="19" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
       <trigger>
@@ -266,6 +269,12 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="child_rsc1:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
         <rsc_op id="19" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
        <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-3.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/notify-3.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/notify-3.exp
@@ -188,6 +188,12 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="child_rsc1:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="child_rsc1:0_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="9" operation="stop" operation_key="child_rsc1:1_stop_0" on_node="node2" on_node_uuid="uuid2"/>
        </trigger>
        <trigger>
@@ -414,6 +420,15 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="child_rsc2:0_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="23" operation="stop" operation_key="child_rsc2:0_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
       <trigger>
@@ -441,6 +456,21 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="child_rsc1:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="child_rsc1:0_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="child_rsc2:0_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="child_rsc2:1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="9" operation="stop" operation_key="child_rsc1:1_stop_0" on_node="node2" on_node_uuid="uuid2"/>
        </trigger>
        <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/novell-252693-2.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/novell-252693-2.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/novell-252693-2.dot
@@ -4,6 +4,7 @@
 "configstoreclone:0_post_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
 "configstoreclone:0_pre_notify_start_0 node2" -> "configstorecloneset_confirmed-pre_notify_start_0" [ style = bold]
 "configstoreclone:0_pre_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
+"configstoreclone:1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "configstoreclone:1_monitor_0 node1" -> "configstorecloneset_start_0" [ style = bold]
 "configstoreclone:1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "configstoreclone:1_monitor_20000 node1" [ style=bold color="green" fontcolor="black" ]
@@ -35,6 +36,7 @@
 "evmsclone:0_post_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
 "evmsclone:0_pre_notify_start_0 node2" -> "evmscloneset_confirmed-pre_notify_start_0" [ style = bold]
 "evmsclone:0_pre_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
+"evmsclone:1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "evmsclone:1_monitor_0 node1" -> "evmscloneset_start_0" [ style = bold]
 "evmsclone:1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "evmsclone:1_post_notify_start_0 node1" -> "evmscloneset_confirmed-post_notify_running_0" [ style = bold]
@@ -59,6 +61,7 @@
 "evmscloneset_start_0" -> "evmsclone:1_start_0 node1" [ style = bold]
 "evmscloneset_start_0" -> "evmscloneset_running_0" [ style = bold]
 "evmscloneset_start_0" [ style=bold color="green" fontcolor="orange" ]
+"evmsdclone:1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "evmsdclone:1_monitor_0 node1" -> "evmsdcloneset_start_0" [ style = bold]
 "evmsdclone:1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "evmsdclone:1_monitor_5000 node1" [ style=bold color="green" fontcolor="black" ]
@@ -74,6 +77,7 @@
 "imagestoreclone:0_post_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
 "imagestoreclone:0_pre_notify_start_0 node2" -> "imagestorecloneset_confirmed-pre_notify_start_0" [ style = bold]
 "imagestoreclone:0_pre_notify_start_0 node2" [ style=bold color="green" fontcolor="black" ]
+"imagestoreclone:1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "imagestoreclone:1_monitor_0 node1" -> "imagestorecloneset_start_0" [ style = bold]
 "imagestoreclone:1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "imagestoreclone:1_monitor_20000 node1" [ style=bold color="green" fontcolor="black" ]
@@ -106,6 +110,7 @@
 "sles10_migrate_from_0 node1" [ style=bold color="green" fontcolor="black" ]
 "sles10_migrate_to_0 node2" -> "sles10_migrate_from_0 node1" [ style = bold]
 "sles10_migrate_to_0 node2" [ style=bold color="green" fontcolor="black" ]
+"sles10_monitor_0 node1" -> "all_stopped" [ style = bold]
 "sles10_monitor_0 node1" -> "sles10_migrate_to_0 node2" [ style = bold]
 "sles10_monitor_0 node1" -> "sles10_start_0 node1" [ style = bold]
 "sles10_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
@@ -115,6 +120,7 @@
 "sles10_stop_0 node2" -> "all_stopped" [ style = bold]
 "sles10_stop_0 node2" -> "sles10_start_0 node1" [ style = bold]
 "sles10_stop_0 node2" [ style=bold color="green" fontcolor="black" ]
+"stonithclone:1_monitor_0 node1" -> "all_stopped" [ style = bold]
 "stonithclone:1_monitor_0 node1" -> "stonithcloneset_start_0" [ style = bold]
 "stonithclone:1_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
 "stonithclone:1_monitor_5000 node1" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/novell-252693-2.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/novell-252693-2.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/novell-252693-2.exp
@@ -704,6 +704,24 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="stonithclone:1_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="evmsdclone:1_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="evmsclone:1_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="imagestoreclone:1_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="configstoreclone:1_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="sles10_monitor_0" on_node="node1" on_node_uuid="85d23ecf-8b5b-4cd3-9344-e1ff5d869d6a"/>
+      </trigger>
+      <trigger>
         <rsc_op id="76" operation="stop" operation_key="sles10_stop_0" on_node="node2" on_node_uuid="2c826922-d092-4862-bedc-de9ae2312117"/>
       </trigger>
     </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order3.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/order3.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/order3.exp
@@ -24,6 +24,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="8" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
@@ -68,6 +71,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="10" operation="stop" operation_key="rsc3_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
@@ -143,6 +149,9 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="8" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
@@ -164,6 +173,18 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc4_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="6" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
        <trigger>
